package com.coydone.test;

import com.coydone.entity.Grade;
import com.coydone.entity.Student;
import com.coydone.mapper.GradeMapper;
import com.coydone.utils.MyBatisUtil;
import org.apache.ibatis.session.SqlSession;
import org.junit.Test;

import java.util.Arrays;
import java.util.List;
import java.util.Scanner;

//省dao层实现类
public class GradeTest {
    SqlSession sqlSession = MyBatisUtil.getSession();
    GradeMapper gradeMapper = sqlSession.getMapper(GradeMapper.class);
    @Test
    public void findAll(){

        List<Grade> grades = gradeMapper.findAll();
        for (Grade grade : grades) {
            System.out.println(grade);
        }
        MyBatisUtil.closeSession();
    }

    @Test
    public void addGrade(){
        Scanner input=new Scanner(System.in);
        System.out.println("请输入编号:");
        int gid=input.nextInt();
        System.out.println("请输入名称:");
        String gname=input.next();

        //调用dao层实现添加
        Grade grade=new Grade();
        grade.setGid(gid);
        grade.setGname(gname);

        int rows=gradeMapper.addGrade(grade);
        sqlSession.commit();

        if(rows>0)
            System.out.println("添加成功");
        else
            System.out.println("添加失败");
    }

    @Test
    public void updateGrade(){
        Scanner input=new Scanner(System.in);
        System.out.println("请输入要修改的编号:");
        int gid=input.nextInt();
        System.out.println("请输入修改的名称:");
        String gname=input.next();

        //调用dao层
        Grade grade=new Grade();
        grade.setGid(gid);
        grade.setGname(gname);

        int rows=gradeMapper.updateGrade(grade);
        sqlSession.commit();
        if(rows>0)
            System.out.println("修改成功");
        else
            System.out.println("修改失败");
    }

    @Test
    public void deleteGrade(){
        Scanner input=new Scanner(System.in);
        System.out.println("请输入要删除的编号:");
        int gid=input.nextInt();

        int rows=gradeMapper.deleteGrade(gid);
        sqlSession.commit();
        if(rows>0)
            System.out.println("删除成功");
        else
            System.out.println("删除失败");
    }

    @Test
    public void findById(){
        Scanner input=new Scanner(System.in);
        System.out.println("请输入要查询的编号:");
        int gid=input.nextInt();

        //调用dao层
        Grade grade = gradeMapper.findById(gid);
        if(grade!=null){
            System.out.println(grade);
        }

    }


    @Test
    //删除多条
    public void deleteGrades(){
        List<Integer> gids = Arrays.asList(209, 210, 211);
        int rows = gradeMapper.deleteGrades(gids);

        sqlSession.commit();
        if(rows>0)
            System.out.println("删除成功");
        else
            System.out.println("删除失败");
    }

    //查询所有年级及年级所有的学生
    @Test
    public void findAllGradeAndStudent(){
        List<Grade> gradeAndStudent = gradeMapper.findAllGradeAndStudent();
        for (Grade grade : gradeAndStudent) {
            System.out.println(grade.getGname());
            List<Student> students = grade.getStudents();
            for (Student student : students) {
                System.out.println(student);
            }
        }
    }


}
